	var LANG = Load("LANG");
	var isRestoring = false;
	
	if (!IsValidLang())
	{
/*		LANG = location.search.match(new RegExp("lang" + "=(.*?)($|\&)", "i"));
		
		if (LANG == null)
		{
			SetLangDefault();
		}
		else
		{
			LANG = LANG[1];
			
			if (!IsValidLang())
			{
				SetLangDefault();
			}
		}
*/
		LANG = GetRequestParam("lang");
		
/*		if (LANG == "0")
		{
			LANG = 0;
		}
		else if (LANG == "1")
		{
			LANG = 1;
		}
*/		
		if (!IsValidLang())
		{
			SetLangDefault();
		}
	}
	
	Save("LANG", LANG);
	
	var isAndroid = /android/i.test(navigator.userAgent);
	var isIOS = /(ipad|iphone|ipod)/i.test(navigator.userAgent);
	
//	if (isAndroid || isIOS)
//	{
//		document.addEventListener('deviceready', InitCordovaFunc, false);
//	}
	
//	alert("isAndroid = " + isAndroid);
//	alert("isIOS = " + isIOS);
  

	$(document).ready(function()
	{
		InitLangButton();
		
		$('#header').click(ScrollTop);
		
		$('#facebook').parent('div').addClass('facebook');
	});
	
	function IsValidLang()
	{
		return (LANG != null && LANG != "" && (LANG == 0 || LANG == 1));
	}
	
	function SetLangDefault()
	{
		LANG = 0;
	}
	
	function GetXML(filename, callback, async)
	{
		callback = callback || null;
		async = async || true;
		
		$.ajax(
		{
			method: "GET",
			url: filename + ".xml",
			dataType: "xml",
			async: async,
			success: function(data, textStatus, jqXHR)
			{
				callback(data);
			}
		});
	}
	
	function ChangeLang()
	{
		if (LANG == 0)
		{
			LANG = 1;
		}
		else
		{
			LANG = 0;
		}
		
		Save("LANG", LANG);
	}
	
	function GetLangCode()
	{
		if (LANG == 1)
		{
			return "en";
		}
		else
		{
			return "zh";
		}
	}
	
	function GetXMLStr(object)
	{
		if (LANG == 0 && object.zh != null)
		{
			return object.zh;
		}
		else (LANG == 1 && object.en != null)
		{
			return object.en;
		}
		
		return "";
	}
	
	
	function DebugLog(string)
	{
		$('#debugLog').html($('#debugLog').html() + "</br>" + string);
	}
	
	function Save(key, value)
	{
		if (AllowStorage())
		{
			localStorage.setItem(key, value);
		}
	}
	
	function Load(key)
	{
		if (AllowStorage())
		{
			if (localStorage[key] != null)
			{
				return localStorage[key];
			}
		}
		
		return "";
	}
	
	function Remove(key)
	{
		if (AllowStorage())
		{
			localStorage.removeItem(key);
		}
	}
	
	function SaveSessionStorage(key, value)
	{
		if (AllowStorage())
		{
			sessionStorage.setItem(key, value);
		}
	}
	
	function LoadSessionStorage(key)
	{
		if (AllowStorage())
		{
			if (sessionStorage[key] != null)
			{
				return sessionStorage[key];
			}
		}
		
		return "";
	}
	
	function RemoveSessionStorage(key)
	{
		if (AllowStorage())
		{
			sessionStorage.removeItem(key);
		}
	}
	
	function AllowStorage()
	{
		return (typeof(Storage) !== "undefined");
	}
	
	function GetObjectAsArray(object)
	{
		if (object == null)
		{
			return [];
		}
		else
		{
			if ($.isArray(object))
			{
				return object;
			}
			else
			{
				return [object];
			}
		}
	}
	
	function NativeAlert(title, message, buttonText)
	{
		if (isAndroid || isIOS)
		{
			navigator.notification.alert(
				message,  // message
				null,         // callback
				title,            // title
				buttonText               // buttonName
			);
		}
		else
		{
			alert(message);
		}
		
		title = "";
		message = "";
		buttonText = "";
	}
	
	function NativeConfirm(title, message, buttonTextArray, callback)
	{
//		if (false)
		if (isAndroid || isIOS)
		{
			navigator.notification.confirm(
				message, // message
				callback,            // callback to invoke with index of button pressed
				title,           // title
				buttonTextArray     // buttonLabels
			);
		}
		else
		{
			callback(confirm(message));
		}
		
		title = "";
		message = "";
		buttonTextArray.length = 0;
	}
	
	function InitCordovaFunc()
	{
//		alert("InitCordovaFunc()");
	
		document.addEventListener("backbutton", null, false);
		
		InitAdMob();
		
//		alert("InitCordovaFunc() End");
	}
	
	function OpenWebPage(link)
	{
		var lvOpenPage = false;
			
		if (isAndroid || isIOS)
		{	
			lvOpenPage = HaveConnection();

			if (!lvOpenPage)
			{
				NativeConfirm(GetMsgText("REMINDER"), GetMsgText("NO_CONNECTION"), [GetMsgText("CONFIRM"), GetMsgText("CANCEL")],
				function(param)
				{
					if (param == 1)
					{
						ActualOpenWebPage(link);
					}
				});
			}
		}

		if (lvOpenPage)
		{
			ActualOpenWebPage(link);
		}
	}

	function ActualOpenWebPage(link)
	{
		if (isAndroid)
		{
			navigator.app.loadUrl(link, {openExternal : true});
		}
		else if (isIOS)
		{
//			window.open(link, '_system');
			cordova.InAppBrowser.open(link, '_system');
		}

		link = "";
	}

	function HaveConnection()
	{
		return (navigator.connection.type != Connection.NONE);
	}

	function InitLangButton()
	{
		var lvButton = $("#lang");
		
		if (LANG == 0)
		{
			lvButton.html("ENG");
		}
		else
		{
			lvButton.html("中文");
		}

		lvButton.click(Click_LangButton);
		lvButton.addClass('headerButton');
		
		lvButton = null;
	}

	function InitBackButton()
	{
		var lvButton = $("#back");

		lvButton.click(Click_BackButton);
		lvButton.addClass('headerButton');

		if (LANG == 0)
		{
			lvButton.html("返回");
		}
		else
		{
			lvButton.html("Back");
		}

		lvButton = null;

		// Init Android Back button

		if (isAndroid)
		{
			document.addEventListener('deviceready', function()
			{
				document.addEventListener("backbutton", Click_BackButton, false);
			}, false);
		}
	}

	function Click_LangButton()
	{
		ChangeLang();
//		location.reload();

		var lvRequestParam = {};
		lvRequestParam = GetAllRequestParam(lvRequestParam);

		lvRequestParam["lang"] = LANG;

		GoToView(VIEW_INDEX, lvRequestParam);
	}

	function Click_BackButton()
	{
//		window.history.back();

		GoToView(VIEW_INDEX_BACK);
	}

	function Location(link)
	{
		location.href = link;
	}

	function GetRequestParam(key)
	{
		var lvString = location.search.match(new RegExp(key + "=(.*?)($|\&)", "i"));

		if (lvString == null)
		{
			lvString = "";
		}
		else
		{
			lvString = lvString[1];
		}

		return lvString;
	}

	function GetAllRequestParam(returnObj)
	{
		if (returnObj == null)
		{
			returnObj = {};
		}

		var lvArray = location.search.split("?");

		if (lvArray.length > 0 && lvArray[0] == "")
		{
			lvArray.splice(0, 1);
			
			if (lvArray.length == 1)
			{
				lvArray = lvArray[0].split("&");

				for (var i=0; i<lvArray.length; i++)
				{
					var lvParam = lvArray[i].split("=");
					
					if (lvParam.length == 2)
					{
						returnObj[lvParam[0]] = lvParam[1];
					}
					
					lvParam.length = 0;
				}
			}
				
			lvArray.length = 0;
		}
		
		return returnObj;
	}

	function GoToView(viewIndex, requestParam)
	{
		var lvLink;

		switch(viewIndex)
		{
			case 0: lvLink = "index.html"; break;
			case 1: lvLink = "mode_basic.html"; break;
			case 2: lvLink = "mode_interchange.html"; break;
			case 3: lvLink = "mode_interchange_station.html"; break;
			case 4: lvLink = "mode_place.html"; break;
			case 5: lvLink = "faq.html"; break;
			case 6: lvLink = "disclaimer.html"; break;
			case 7: lvLink = "about.html"; break;
			
			default: return; break;
		}

		// Remove Android Back button

		if (isAndroid)
		{
			document.removeEventListener("backbutton", Click_BackButton, false);
		}
		
		requestParam = requestParam || null;
		
		if (requestParam == null)
		{
			requestParam = {lang: LANG};
		}
		
		if (requestParam != null)
		{
			if (requestParam["lang"] == null)
			{
				requestParam["lang"] = LANG;
			}
			
			lvLink += "?";
			
			var lvNumParam = 0;
			
			$.each(requestParam, function(key, data)
			{
				if (lvNumParam > 0)
				{
					lvLink += "&";
				}
				
				lvLink += key + "=" + data;
				
				lvNumParam++;
			});
		}

		Location(lvLink);
	}
	
	function StrReplace(string, paramArray)
	{
		if (paramArray != null && paramArray.length != null && paramArray.length % 2 == 0)
		{
			for (var i=0; i<paramArray.length; i+=2)
			{
				string = string.replace(paramArray[i], paramArray[i+1]);
			}
		}

		return string;
	}

	function ScrollTop()
	{
		$('body').scrollTop(0);
	}

	function SetUpHelpBar(jQueryObj)
	{
		jQueryObj = jQueryObj || null;

		if (jQueryObj == null)
		{
			jQueryObj = $('#help');
		}

		jQueryObj.collapsible(
		{
/*			collapsedIcon: "info",
			expandedIcon: "info",
			collapsed: (Load("ExpandHelpBar") == "F"),
			expand: function(event, ui)
			{
				Save("ExpandHelpBar", "T");
			},
			collapse: function(event, ui)
			{
				Save("ExpandHelpBar", "F");
			}*/

			collapsedIcon: "",
			expandedIcon: "",
			collapsed: false,
			disabled: true
		});

		jQueryObj.find('div.ui-collapsible-content').addClass('ui-mini');
	}
	
function overlayShow()
{
	if (!$('#overlay').length)
	{
		$('body').prepend('<div id="overlay"></div>');
	}
	
	$('#overlay').show();
}

function overlayHide()
{
	$('#overlay').hide();
}

function OpenFbPage()
{
	if (isAndroid)
	{
		OpenWebPage("fb://page/1741695776058705/");
	}
	else if (isIOS)
	{
		OpenWebPage("fb://profile/1741695776058705/");
	}
}
