	var VIEW_INDEX = 1;
	var VIEW_INDEX_BACK = 0;

	var coreXML = null;
	var onConfirmAddBookmarkIndex = -1;

	var useNewCoreXML = true;
	var lineObj = null;

//	var current_info_tab_index;
	var current_line;
	var current_search_mode;
	var current_station;

	var PRE_DEFINED =
	{
		LINES:
		{
			TWL:["TSW","TWH","KWH","KWF","LAK","MEF","LCK","CSW","SSP","PRE","MOK","YMT","JOR","TST","ADM","CEN"],
			KTL:["TIK","YAT","LAT","KWT","NTK","KOB","CHH","DIH","WTS","LOF","KOT","SKM","PRE","MOK","YMT","HOM","WHA"],
			ISL:["KET","HKU","SYP","SHW","CEN","ADM","WAC","CAB","TIH","FOH","NOP","QUB","TAK","SWH","SKW","HFC","CHW"],
			TKL:["POA","HAH","LHP","TKO","TIK","YAT","QUB","NOP"],
			SIL:["SOH","LET","WCH","OCP","ADM"],
			TCL:["TUC","SUN","TSY","LAK","NAC","OLY","KOW","HOK"],
			DRL:["DIS","SUN"],
			ERL:["SHS","FAN","TWO","TAP","UNI","FOT","SHT","TAW","KOT","MKK","HUH"],
			WRL:["TUM","SIH","TIS","LOP","YUL","KSR","TWW","MEF","NAC","AUS","ETS","HUH"],
			MOL:["WKS","MOS","HEO","TSH","SHM","CIO","STW","CKT","TAW"]
		},
		STATIONS: ["ADM","AUS","CAB","CEN","CHH","CHW","CIO","CKT","CSW","DIH","DIS","ETS","FAN","FOH","FOT","HAH","HEO","HFC","HKU","HOK","HOM","HUH","JOR","KET","KOB","KOT","KOW","KSR","KWF","KWH","KWT","LAK","LAT","LCK","LHP","LOF","LOP","MEF","MKK","MOK","MOS","NAC","NOP","NTK","OLY","POA","PRE","QUB","SHM","SHS","SHT","SHW","SWH","SIH","SKM","SKW","SSP","STW","SUN","SYP","TAK","TAP","TAW","TIH","TIK","TIS","TKO","TSH","TST","TSW","TSY","TUC","TUM","TWH","TWO","TWW","UNI","WAC","WHA","WKS","WTS","YAT","YMT","YUL","SOH","LET","WCH","OCP"]
	};

//	var bookmark_list = new Array();

//	var EXIT_INFO_SORTING = 0;

//	$.mobile.page.prototype.options.domCache = true;

//	try
//	{
	$(document).ready(function()
	{
//		DebugLog("document ready");

//		$.mobile.selectmenu.prototype.options.hidePlaceholderMenuItems = false;

//		$("#line").selectmenu({
//			hidePlaceholderMenuItems: false
//		});


//		$("#station").append("<option class=\"default\">" + GetTranslation("SELECT_STATION") + "</option>");
		
//		InitTranslation();

		Load_PageSavedData();

		if (AllowStorage())
		{
			BookmarkManager.Init();
		}
		else
		{
			var lvStation = GetRequestParam("station");

			if (lvStation != "")
			{
				current_line = "";
				current_search_mode = 1;
				current_station = lvStation;
			}

			lvStation = null;
		}

		$('#map').button(
		{
			disabled: true/*,
			icon: "location"
*/		}).click(OpenMap);

		Set_StationInfo(current_station);

		InitBackButton();

		var lvFromView = GetRequestParam("fromView");

		if (lvFromView != "")
		{
			lvFromView = parseInt(lvFromView);

			if (!isNaN(lvFromView))
			{
				VIEW_INDEX_BACK = lvFromView;
			}
		}

		var _TRANSLATION =
		{
			headerText: ["落車指南", "Alighting Planner"],
			TEXT_tab_input_select: ["選擇落車站", "Select alighting station"],
			TEXT_tab_input_text: ["輸入落車站", "Input alighting station"]
		};

		$.each(_TRANSLATION, function(key, data)
		{
			$("#" + key).text(data[LANG]);
		});

		_TRANSLATION =
		{
			map: ["開啟此車站 Google Maps", "Open Google Maps of this station"]
		};

		$.each(_TRANSLATION, function(key, data)
		{
			$("#" + key).val(data[LANG]).button("refresh");
		});
/*
		_TRANSLATION =
		{
			marquee: ["所有資料僅供參考(TBC)", "All information is for reference only(TBC) All information is for reference only(TBC)"]
		};

		$.each(_TRANSLATION, function(key, data)
		{
			$("#" + key).html(data[LANG]);
		});
*/
		_TRANSLATION = null;

/*		$('#marquee').marquee({
			 delayBeforeStart: 0,
			 gap: 0,
			 duration: 5000
		});
*/


//		$('#tmpSelect').hide();

/*		$('.anyClass').liMarquee(
		{
//			window.innerWidth
		});
*/
		Init_Tab_SearchMode();

		Init_SearchMode_Default();
		Init_SearchMode_InputStation();

		CreateHelpBar();

/*		if (useNewCoreXML)
		{
			GetXML("data/core2", ProcessCoreXML);
		}
		else
		{
			GetXML("data/core", ProcessCoreXML);
		}
*/
/*		if(( /(ipad|iphone|ipod|android|windows phone)/i.test(navigator.userAgent) ))
		{
			document.addEventListener('deviceready', InitCordovaFunc, false);
		}
*/
	});

	function Set_StationInfo(value)
	{
//		$.mobile.loading('show');
		overlayShow();

		var lvMap = $('#map');

		lvMap.button("disable");

		$('#tabs').html("");
		BookmarkManager.ClearPageBookmark();

/*		if (station == "N")
		{
			Remove("station");
			return;
		}
		else if (!isRestoring)
		{
			Save("station", station);
			Remove("tabIndex");
		}
*/
		current_station = value;

		if (current_station == undefined || current_station == 'undefined' || current_station == "")
		{
			SetHelpBarContentDefault();
//			$.mobile.loading('hide');
			overlayHide();

			return ;
		}

		GetXML("data/station/" + current_station, function(data)
		{
			if (data == null)
			{
//				$.mobile.loading('hide');
				overlayHide();
				return ;
			}

			var lvStationLabel = current_station;
			var lvStation = $.xml2json(data);

			data = null;

			if (lvStation.geo != null)
			{
				lvMap.data("geo", lvStation.geo);
				lvMap.button("enable");
			}

			var lvString = "";
			var activeButton = true;

			// tab generation

			lvString += "<div data-role=\"navbar\"><ul>";

			var lvLines = null;

			if (lvStation.line != null)
			{
				lvLines = $(lvStation.line);

				for (var i=0; i<lvLines.length; i++)
				{
					lvString += "<li><a href=\"#" + lvLines[i].label + "\"";

//						if (activeButton)
//						{
//							lvString += " class=\"ui-btn-active\"";
//						}

					lvString += " class=\"border_bottom_" + lvLines[i].label + "\"";

					activeButton = false;

					lvString += ">" + GetCoreText(lvLines[i].label) + "</a></li>";
				}
			}

//				if (lvStation.exitInfo != null)
//				{
				lvString += "<li><a href=\"#" + "exitInfo" + "\">"
//				}
/*				if (LANG == 1)
			{
				lvString += "Exit info";
			}
			else
			{
				lvString += "出口資訊";
			}
*/
			+ GetCoreText("EXIT_INFO")

			+ "</a></li>"

			+ "</ul></div>";

			// tab content generation

//			var _selectTabIndex = 0;

			// Alight info

			if (lvLines != null)
			{
				for (var i=0; i<lvLines.length; i++)
				{
					var lvPlatforms = $(lvLines[i].platform);

					lvString += "<div id=\"" + lvLines[i].label + "\">";

/*					if ($("#line").val() == lvLines[i].label)
					{
						_selectTabIndex = i;
					}*/

					if (lvPlatforms.length > 0)
					{
						lvString += "<div class=\"ui-bar ui-bar-a station-color-block " + lvStationLabel + "\" style=\"margin-top: 10px\">";

						if (lvLines.length == 1)
						{
//							lvString += GetCoreText("STATION_HEADER_2", ["@station", GetTranslation(lvStationLabel)]);
							lvString += '<span class="chinese-name">' + TRANSLATION[lvStationLabel][0] + '</span><br/>' + TRANSLATION[lvStationLabel][1];
						}
						else
						{
//							lvString += GetCoreText("STATION_HEADER", ["@line", GetCoreText(lvLines[i].label), "@station", GetTranslation(lvStationLabel)]);
							lvString += '<span class="chinese-name">' + TRANSLATION[lvStationLabel][0] + '</span><br/>' + TRANSLATION[lvStationLabel][1] + '<br/><br/><span style="float:left">' + GetCoreText(lvLines[i].label) + ((LANG==0)?'落車':' Alighting') + '</span>'
						}

						GetTranslation(lvStationLabel) + GetCoreText("STATION");

//							lvString += GetCoreText(lvLines[i].label) + " " + GetCoreText("ARRIVING_ALIGHTING_PLATFORM") + "</div>";

						lvString += "</div>";

						if (lvLines[i].lineInfo != null)
						{
							lvString += "<div class=\"ui-body ui-body-a ui-mini\" style=\"margin: 0\">";

							if (lvLines[i].lineInfo.override == null)
							{
								lvString += GetMsgText(lvLines[i].lineInfo);
							}
							else
							{
								lvString += GetXMLStr(lvLines[i].lineInfo.override);
							}

							lvString += "</div>";
						}

						for (var j=0; j<lvPlatforms.length; j++)
						{
							var lvPlatform = lvPlatforms[j];
							var lvPlatformNumbers = GetObjectAsArray(lvPlatform.number);

							lvString += "<div class=\"ui-bar ui-bar-a border_bottom_" + lvLines[i].label + "\" style=\"margin-top: 10px; padding-left: 0; background: white; border: 3px solid silver\"><table><tr><td><img src=\"img/arrow.png\" style=\"float: left; margin-right: 5px\" />";

							for (var k=0; k<lvPlatformNumbers.length; k++)
							{
								lvString += "<div class=\"newPlatformNo bg_" + lvLines[i].label + "\">" + lvPlatformNumbers[k] + "</div>";
							}

//								lvString += "</td><td>" + GetCoreText("PLATFORM") + " " + GetCoreText(lvPlatform.label) + "</td></tr></table>"
							lvString += "</td><td>" + GetCoreText(lvPlatform.label) + "</td></tr></table>"

							+ "</div>"

							+ "<div class=\"ui-body ui-body-a\" style=\"padding: 0\">"
							
							+ "<table class=\"posInfoTable\">"
							
							+ "<tr style=\"text-align: left\">"
							
							+ "<th>" + ((LANG == 1)? 'Alight at<br/>(Car No - Door No)': '從(卡-門)落車') + "</th><th>"// + GetTranslation("EXIT") + "<img src=\"script/images/icons-png/tag-black.png\" style=\"float:right\" onclick=\"BookmarkReminder()\" /></th>"
							
//								+ "<img alt=\"Exit\" style=\"float: left\" src=\"img/exit.png\" /><img src=\"script/images/icons-png/tag-black.png\" style=\"float:right\" onclick=\"BookmarkReminder()\" /></th>"
							+ ((LANG == 1)? 'To Exit': '到出口') + " <img alt=\"Exit\" style=\"vertical-align: middle\" src=\"img/exit.png\" />"// + "<a style=\"margin: 0; float: right\" class=\"ui-btn ui-shadow ui-corner-all ui-icon-info ui-btn-icon-notext\" onclick=\"BookmarkReminder()\"></a></th>"
							
							+ "</tr>";
							
							var lvInfos = GetObjectAsArray(lvPlatform.info);
							
							for (var k=0; k<lvInfos.length; k++)
							{
								var lvInfo = lvInfos[k];
								
								if (lvInfo.override != null)
								{
									lvString += "<tr><td colspan=\"2\">";
									
									if (lvInfo.override.icon != null)
									{
//											lvString += "<img src=\"script/images/icons-png/info-black.png\" class=\"ui-li-icon\"/> ";
										lvString += "<a style=\"margin: 0; float:left\" class=\"ui-nodisc-icon ui-btn ui-shadow ui-corner-all ui-icon-alert ui-btn-icon-notext ui-alt-icon\"></a>";
									}
									
									if (lvInfo.override.label != null)
									{
										lvString += GetTranslation(lvInfo.override.label);
									}
									else
									{
										lvString += GetXMLStr(lvInfo.override);
									}
									
									lvString += "</td></tr>";
										
									var lvAlightPosS = GetObjectAsArray(lvInfo.alightPos);
									
									for (var m=0; m<lvAlightPosS.length; m++)
									{
//											lvString += "<br />"
										lvString += "<tr><td>"

//											+ "第 " + lvAlightPosS[m].car + " 卡 第 " + lvAlightPosS[m].door + " 門";

										+ "<div class=\"posNoBox\">" + lvAlightPosS[m].car + "</div><div class=\"posNoBox_door\">" + lvAlightPosS[m].door + "</div>";
										
										if (lvAlightPosS[m].label != null && lvAlightPosS[m].label != "")
										{
//												lvString += "<div class=\"left\">" + lvAlightPosS[m].label + "</div>";
											lvString += "<img alt=\"" + lvAlightPosS[m].label + "\" style=\"float: left\" src=\"img/" + lvAlightPosS[m].label + ".png\" />";
										}

										lvString += "</td><td>";

										if (AllowStorage())
										{
//												lvString += "<div class=\"left\"><img src=\"script/images/icons-png/tag-black.png\" onclick=\"PressBookmark(this)\" data-bookmark-index=\"" + BookmarkManager.GetPageBookmarkLength() + "\"/></div>";
											lvString += "<div class=\"left\"><a style=\"margin: 0\" class=\"ui-btn ui-shadow ui-corner-all ui-icon-tag ui-btn-icon-notext\" onclick=\"PressBookmark(this)\" data-bookmark-index=\"" + BookmarkManager.GetPageBookmarkLength() + "\"></a></div>";
												
											BookmarkManager.AddPageBookmark(new Bookmark(lvStationLabel, lvLines[i].label, lvPlatformNumbers, null, lvAlightPosS[m].car, lvAlightPosS[m].door, lvAlightPosS[m].label, lvPlatform.label));
										}

										lvString += "</td></tr>";

/*											if (AllowStorage())
										{	
											lvString += "<div class=\"left\"><img src=\"script/images/icons-png/tag-black.png\" onclick=\"PressBookmark(this)\" data-bookmark-index=\"" + BookmarkManager.GetPageBookmarkLength() + "\"/></div>";
										
											BookmarkManager.AddPageBookmark(new Bookmark($('#station').val(), lvLines[i].label, lvPlatformNumbers, null, lvAlightPosS[m].car, lvAlightPosS[m].door, null));
										}
*/											
//											var lvType = GetObjectAsArray(lvAlightPosS[m].label);



//											lvString += "</td>";

/*											for (var n=0; n<lvType.length; n++)
										{
											lvString += " (" + lvType[n] + ") ";
										}
*/										}

//										lvString += "</td></tr>";
								}
								else
								{
									var lvExit = GetObjectAsArray(lvInfo.exit);

									if (lvExit.length > 0)
									{
										var lvAlightPosS = GetObjectAsArray(lvInfo.alightPos);

										var lvAlightPosCar = new Array();
										var lvAlightPosDoor = new Array();
										var lvAlightPosType = new Array();

										for (var m=0; m<lvAlightPosS.length; m++)
										{
											lvAlightPosCar.push(lvAlightPosS[m].car);
											lvAlightPosDoor.push(lvAlightPosS[m].door);
											lvAlightPosType.push(lvAlightPosS[m].label);
										}

										for (var m=0; m<lvAlightPosS.length; m++)
										{
//												lvString += "<tr><td>" + "第 " + lvAlightPosS[m].car + " 卡 第 " + lvAlightPosS[m].door + " 門";
											lvString += "<tr><td>";

/*												if (AllowStorage())
											{
												lvString += "<div class=\"left\"><img src=\"script/images/icons-png/tag-black.png\" onclick=\"PressBookmark(this)\" data-bookmark-index=\"" + BookmarkManager.GetPageBookmarkLength() + "\"/></div>";

												BookmarkManager.AddPageBookmark(new Bookmark($('#station').val(), lvLines[i].label, lvPlatformNumbers, lvExit, lvAlightPosS[m].car, lvAlightPosS[m].door, null));
											}
*/												
											lvString += "<div class=\"posNoBox\">" + lvAlightPosS[m].car + "</div><div class=\"posNoBox_door\">" + lvAlightPosS[m].door + "</div>";												

//												var lvType = GetObjectAsArray(lvAlightPosS[m].label);

											if (lvAlightPosS[m].label != null && lvAlightPosS[m].label != "")
											{
												lvString += "<img alt=\"" + lvAlightPosS[m].label + "\" style=\"float: left\" src=\"img/" + lvAlightPosS[m].label + ".png\" />";
											}
											
											lvString += "</td>";
											
/*												for (var n=0; n<lvType.length; n++)
											{
												lvString += " (" + lvType[n] + ") ";
											}
											
											lvString += "</td>";
*/												
											if (m == 0)
											{	
												lvString += "<td rowspan=\"" + lvAlightPosS.length + "\">";
										
												for (var n=0; n<lvExit.length; n++)
												{
													lvString += "<div class=\"newExitBoxLarge\"";
													
													if (AllowStorage())
													{	
														lvString += " onclick=\"PressBookmark(this)\" data-bookmark-index=\"" + BookmarkManager.GetPageBookmarkLength() + "\"";

//															BookmarkManager.AddPageBookmark(new Bookmark($('#station').val(), lvLines[i].label, lvPlatformNumbers, lvExit[m], lvAlightPosS[m].car, lvAlightPosS[m].door, null));
														BookmarkManager.AddPageBookmark(new Bookmark(lvStationLabel, lvLines[i].label, lvPlatformNumbers, lvExit[n], lvAlightPosCar, lvAlightPosDoor, lvAlightPosType, lvPlatform.label));
													}
													
													lvString += ">" + lvExit[n] + "</div>";
												}
												
												lvString += "</td>";
											}
											
											lvString += "</tr>";
										}
									}
								}
							}
							
							var lvAddInfo = GetObjectAsArray(lvPlatform.addInfo);
															
							for (var k=0; k<lvAddInfo.length; k++)
							{
		//						lvString += "<tr><td colspan=\"2\"><img src=\"script/images/icons-png/info-black.png\" class=\"ui-li-icon\"/> ";//<img src=\"script/images/icons-png/info-black.png\" class=\"ui-li-icon\"/>";
								lvString += "<tr><td colspan=\"2\"><a style=\"margin: 0; float:left\" class=\"ui-nodisc-icon ui-btn ui-shadow ui-corner-all ui-icon-alert ui-btn-icon-notext ui-alt-icon\"></a>";
								
								if (lvAddInfo[k].label != null)
								{
									lvString += GetTranslation(lvAddInfo[k].label);
								}
								else
								{
									lvString += GetXMLStr(lvAddInfo[k]);
								}
								
								lvString += "</td></tr>";
							}
							
							lvAddInfo.length = 0;
							
							lvString += "</table>"
															
							+ "</div>";
						}
					}

					lvString += "</div>";
				}
			}
			
			lvLines = null;
			
			// Exit Info
			
			lvString += "<div id=\"exitInfo\" class=\"ui-body ui-body-a ui-corner-all\" style=\"padding:0;margin-top: 10px\">"
			
//			+ "<div class=\"ui-bar ui-bar-a\">" + GetCoreText("STATION_HEADER_3", ["@station", GetTranslation(lvStationLabel)]) + "<br/>" + GetCoreText("EXIT_INFO") + "</div>"
			
			+ '<div class="ui-bar ui-bar-a station-color-block ' + lvStationLabel + '"><span class="chinese-name">' + TRANSLATION[lvStationLabel][0] + '</span><br/>' + TRANSLATION[lvStationLabel][1] + '</div>'
	
			+ "<div class=\"ui-body ui-body-a ui-mini\" style=\"margin: 0\">" + GetCoreText("REFERENCE_ONLY") + "</div><div class=\"ui-body ui-body-a\" style=\"padding:0;margin-top: 10px\">";
			
//				+ "<div id=\"exitInfo\" class=\"ui-body ui-body-a ui-corner-all\" style=\"padding:0;margin-top: 10px\">";
			
//				if (lvStation.exit != null && lvStation.place != null)
			if (lvStation.place != null)
			{
//					var lvExits = GetObjectAsArray(lvStation.exit);
				var lvPlaces = GetObjectAsArray(lvStation.place);
				
				lvString += //'<form><input id="filterInput" data-type="search"></form>'

				'<table id="exitInfoTable" class="width100" data-filter="true" data-filter-placeholder="' + ((LANG == 0)? '按此搜尋地點': 'Press to search place')

				+ "\"><thead style=\"text-align:left; white-space:nowrap\"><tr class=\"bg_grey\"><th>"

/*					if (LANG == 1)
				{
					lvString += "Place";
				}
				else
				{
					lvString += "地點";
				}
*/					
				+ GetCoreText("PLACE")

				+ '</th><th>';
				
				if (LANG == 1)
				{
					lvString += "Exit";
				}
				else
				{
					lvString += "出口";
				}

				lvString += " <img alt=\"Exit\" style=\"vertical-align: middle\" src=\"img/exit.png\" /></th></tr></thead><tbody>";

				for (var i=0; i<lvPlaces.length; i++)
				{
//						lvString += "<li>" + GetXMLStr(lvPlaces[i]);

					if (i % 2 == 1)
					{
						lvString += '<tr class="bg_grey">';
					}
					else
					{
						lvString += "<tr>";
					}

					lvString += "<td>" + GetXMLStr(lvPlaces[i]);
					
					var lvAddInfo = GetObjectAsArray(lvPlaces[i].addInfo);
					
					for (var j=0; j<lvAddInfo.length; j++)
					{
						lvString += "<br />" + GetXMLStr(lvAddInfo[j]);
					}

					var lvPlaceExits = GetObjectAsArray(lvPlaces[i].exit);
					
					lvString += "</td>";

					if (lvPlaceExits.length > 1)
					{
						lvString += "<td style=\"display: flex\">";
					}
					else
					{
						lvString += "<td>";
					}

					for (var j=0; j<lvPlaceExits.length; j++)
					{
//							lvString += " " + lvPlaceExits[j];

						if (j > 0)
						{
							lvString += " ";
						}

						lvString += "<div class=\"newExitBox\">" + lvPlaceExits[j] + "</div>";
					}

					lvPlaceExits.length = 0;
					lvPlaceExits = null;

//						lvString += "</li>";
					lvString += "</td></tr>";
				}

//					lvString += "</ul>";
				lvString += "</tbody></table></div>";

//					lvString += "</div>";

				lvPlaces.length = 0;
				lvPlaces = null;
			}

			lvStation = null;

			lvString += "</div>";

/*			if (isRestoring)
			{
				_selectTabIndex = Load("tabIndex");
				isRestoring = false;
			}*/

//			$('#tabs').html(lvString).trigger("create").tabs("refresh").on( "tabsactivate", OnTabsActivate).tabs("option", "active", _selectTabIndex);
			$('#tabs').html(lvString).trigger("create").tabs("refresh").tabs("option", "active", 0);

			var lvTabButton = $('#tabs').find("a.ui-tabs-anchor");
			var lvTabButtonHeight = 0;
			
			for (var i=0; i<lvTabButton.length; i++)
			{
				var lvHeight = $(lvTabButton[i]).height();

				if (lvHeight > lvTabButtonHeight)
				{
					lvTabButtonHeight = lvHeight;
				}
			}

			for (var i=0; i<lvTabButton.length; i++)
			{
				$(lvTabButton[i]).height(lvTabButtonHeight);
			}

			var lvStationString = GetTranslation(lvStationLabel);
			var _TRANSLATION = ['<ul style="padding-left: 10px; margin-top: 0; margin-bottom: 0"><li>預先從 (車卡號數 - 車門號數) 上車往<b>' + lvStationString + '</b>站，到站更快到出口</li><li>月台閘門 / 地面設有<b>車卡號數</b>標貼</li><li>可按下<b>出口字母</b> / <b>書籤</b>按鈕將落車位置加到首頁書籤</li><li>可按下<b>出口資訊</b>按鈕查看出口附近地點</li></ul>', '<ul style="padding-left: 10px; margin-top: 0; margin-bottom: 0"><li>Board the train at (Car No - Door No) to <b>' + lvStationString + '</b> Station to reach Exit quicker</li><li><b>Car No</b> are shown on platform doors / floor</li><li>Press <b>Exit Alphabet</b> / <b>Bookmark</b> button to bookmark Alighting Position to Homepage</li><li>Press <b>Exit Info</b> button to view nearby places</li></ul>'];

			SetHelpBarContent(_TRANSLATION[LANG]);

//			$.mobile.loading('hide');
			overlayHide();

			_TRANSLATION.lenth = 0;

			lvString = null;
			lvTabButton = null;


//				$('#exitInfoTable').table( "rebuild" );

//				UpdateExitInfoSortButton();
//				ToggleExitInfo();
		});
	}


//}
//catch(e)
//{
//	DebugLog(e);
//	alert(e);
//}

/*	function ToggleExitInfo()
	{		
		if (EXIT_INFO_SORTING == 0)
		{
			$('#sortByExit').show();
			$('#sortByPlace').hide();
			$('#exitInfoSortButton').val("Sort By place").button("refresh").button("enable");//change();
		}
		else
		{
			$('#sortByPlace').show();
			$('#sortByExit').hide();
			$('#exitInfoSortButton').val("Sort By exit").button("refresh").button("enable");//.change();
		}
	}
*/	
/*	function UpdateExitInfoSortButton()
	{
		if (EXIT_INFO_SORTING == 0)
		{
			$('#exitInfoSortButton').val("Sort By place");
		}
		else
		{
			$('#exitInfoSortButton').val("Sort By exit");
		}
	}
*/	
/*	function ClickExitInfoSortButton()
	{
		if (EXIT_INFO_SORTING == 0)
		{
			EXIT_INFO_SORTING = 1;
		}
		else
		{
			EXIT_INFO_SORTING = 0;
		}
		
		ToggleExitInfo();
	}
*/
	function GetPosInfoString(stationObj, infoId)
	{
		var lvString = "";
		var infoObj = stationObj.posInfo[infoId];

		lvString += "<tr><td>" + infoObj.platformNo + "</td><td>" + GetTranslation("TO") + GetTranslation(stationObj.platform[infoObj.platformNo-1].terminus) + "</td></tr>";
		lvString += "<tr><td>" + GetTranslation("CAR_DOOR", ["@num1", infoObj.car, "@num2", infoObj.door]) + "</td></tr>";
		
		return lvString;
	}
	
	function ProcessCoreXML(data)
	{
		if (data == null)
		{
			return ;
		}
		
//		var lvJSON = $.xml2json(data);
		
//		return ;
		
		var lvLine = $('#line');
		
//		lvLine.selectmenu("destroy");
			
//		var lvString = "<optgroup label=\"" + GetTranslation("SELECT_LINE") + "\">";

		var lvString = "<option value=\"N\">" + GetTranslation("SELECT_LINE") + "</option>";

		if (useNewCoreXML)
		{
			lineObj = $.xml2json(data).line;
			
			var allStations = new Array();
			
			$.each(lineObj, function(key, data)
			{
				lvString += "<option value=\"" + key + "\">" + GetCoreText(key) +"</option>";
				
				if (data.station != null)
				{
					for (var i=0; i<data.station.length; i++)
					{
						var station = data.station[i];
						
						if (allStations.indexOf(station) == -1)
						{
							allStations.push(station);
						}
					}
				}
			});
			
			allStations.sort();
			
			var lvStr = '<ul id="stationListview" data-role="listview" data-filter="true" data-filter-reveal="true" data-input="#stationFilter" data-inset="true">';
			
			for (var i=0; i<allStations.length; i++)
			{
				lvStr += '<li><a data-station="' + allStations[i] + '"href="#">' +　GetTranslation(allStations[i]) + '</a></li>';
			}
			
			lvStr += '</ul>';
			
			$('#tab_input_text').append(lvStr);
			$('#stationListview').listview();
			
			allStations.length = 0;		
			lvStr = null;
		}
		else
		{
			coreXML = $(data).children("core");
			
			coreXML.children("line").each(function(index)
			{
				var code = $(this).children("code").text();

				lvString += "<option value=\"" + code + "\">" + GetTranslation(code) +"</option>";
			});
		}
		
//		lvString += "</optgroup>";
		
		lvLine.append(lvString);
		
		lvString = "";
		
//		lvLine.selectmenu();
//		lvLine.selectmenu("option", "hidePlaceholderMenuItems", false);
//		lvLine.selectmenu("refresh");

		var lvRequestLine = GetRequestParam("line");
		
		if (lvRequestLine != "")
		{
			Save("line", lvRequestLine);
			
			isRestoring = true;
			
			$('option[value=' + lvRequestLine +']', lvLine).prop('selected', 'selected').change();
			
			lvRequestLine = "";
		}
		else
		{
			var lvSavedLine = Load("line");
			
			if (lvSavedLine != "")
			{
				isRestoring = true;
				
				$('option[value=' + lvSavedLine +']', lvLine).prop('selected', 'selected').change();
				
				lvSavedLine = "";
			}
			else
			{		
				lvLine.selectmenu("refresh");
			}
		}
		
		lvLine = null;
	}
	
//	function InitCordovaFunc()
//	{
//		alert("InitCordovaFunc()");
	
//		document.addEventListener("backbutton", OnBackKeyDown, false);
		
//		InitAdMob();
		
//		alert("InitCordovaFunc() End");
//	}
	
	function OnBackKeyDown()
	{
		DebugLog("OnBackKeyDown");
		
		navigator.notification.confirm(
			'Exit FastPass?', // message
			function(buttonIndex)
			{
				if (buttonIndex == 1)
				{
					navigator.app.exitApp();
				}
			},            // callback to invoke with index of button pressed
			'Exit',           // title
			['Confirm','Cancel']         // buttonLabels
		);
		
		DebugLog("OnBackKeyDown End");
    }
	
	function OpenMap()
	{
		var lvMap = $('#map');
		
		if (lvMap.data("geo") != null)
		{
			var lvLink = "http://www.google.com/maps/@" + lvMap.data("geo").replace(/ /g,'') + ",19z";
			
//				location.href = "http://www.google.com/maps/@" + lvMap.data("geo").replace(/ /g,'') + ",19z";
//				location.href = "geo:" + lvMap.data("geo").replace(/ /g,'') + "?z=19";

//				alert(lvLink);

//				location.href = lvLink;

//			navigator.app.loadUrl(lvLink , {openExternal : true});

//			window.open(lvLink, '_system');

			OpenWebPage(lvLink);
		}
	}
	
/*	function ClearBookmarkList()
	{
		bookmark_list.length = 0;
	}
*/	
	function PressBookmark(bookmark)
	{
		onConfirmAddBookmarkIndex = parseInt($(bookmark).attr("data-bookmark-index"));
		
		var lvBookmark = BookmarkManager.GetPageBookmark(onConfirmAddBookmarkIndex);
		
		if (!BookmarkManager.CanAddBookmark(lvBookmark))
		{
			NativeAlert(GetMsgText("BOOKMARK"), BookmarkManager.GetErrorMsg(), GetMsgText("DISMISS"));
			return ;
		}
		
		var lvCar = GetObjectAsArray(lvBookmark.car);

		if (lvCar.length == 0 || lvCar.length > 2)
		{
			lvString = "";
			return ;
		}

		// Add line and alighting platform
	
		var lvString = "-" + GetCoreText("ARRIVING_LINE") + ": " + GetCoreText(lvBookmark.line) + "\n-" + GetCoreText("ALIGHTING")
		
		+ "\n-" + GetCoreText("PLATFORM") + ": ";
		
		// Add platform no
	
		for (var i=0; i<lvBookmark.platformNo.length; i++)
		{
			lvString += "(" + lvBookmark.platformNo[i] + ")";
		}
		
		// Add platform label
		
		lvString += " " + GetCoreText(lvBookmark.platformLabel);
		
		// Add alighting position for single available position only
		
		if (lvCar.length == 1)
		{
			lvString += "\n-" + GetCoreText("POSITION") + ": " + lvBookmark.car + "-" + lvBookmark.door;
		}
		
		// Add exit
			
		if (lvBookmark.exit.length > 0)
		{
			lvString += "\n-" + GetCoreText("EXIT") + ": ";
			
			for (var i=0; i<lvBookmark.exit.length; i++)
			{
				if (i > 0)
				{
					lvString += "/";
				}
				
				lvString += lvBookmark.exit[i];
			}
		}
		
		// Add type for single available position only
			
		if (lvCar.length == 1)
		{
			if (lvBookmark.type.length > 0)
			{
				lvString += "\n-" + GetCoreText("TYPE") +": ";
				
				for (var i=0; i<lvBookmark.type.length; i++)
				{
					if (i > 0)
					{
						lvString += "/ ";
					}
					
					lvString += GetCoreText(lvBookmark.type[i]);
				}
			}
		}

		var lvConfirmTitle = GetMsgText("BOOKMARK_ADD");
		var lvConfirmButtonArray;
		
		// Add button text
		
		if (lvCar.length == 1)
		{
			lvConfirmButtonArray = [GetMsgText("CONFIRM"), GetMsgText("CANCEL")];
		}
		else
		{
			// Add alighting position and type for 2-available positions only
			
			lvString += "\n\n" + GetMsgText("SELECT_POSITION")
			
			+ "\n-" + GetMsgText("POSITION_1") + " " + GetMsgText("CAR_DOOR") + ": " + lvBookmark.car[0] + "-" + lvBookmark.door[0] + "\n-" + GetCoreText("TYPE") +": " + GetCoreText(lvBookmark.type[0])
			
			+ "\n\n-" + GetMsgText("POSITION_2") + " " + GetMsgText("CAR_DOOR") + ": " + lvBookmark.car[1] + "-" + lvBookmark.door[1] + "\n-" + GetCoreText("TYPE") +": " + GetCoreText(lvBookmark.type[1]);
			
			lvConfirmButtonArray = [GetMsgText("POSITION_1"), GetMsgText("POSITION_2"), GetMsgText("CANCEL")];
		}
	
		NativeConfirm(lvConfirmTitle, lvString, lvConfirmButtonArray, onConfirmAddBookmark);
				
		lvString = "";
		lvConfirmTitle = "";
		
		lvConfirmButtonArray.length = 0;
	}
	
	function BookmarkReminder()
	{
		NativeAlert(GetMsgText("BOOKMARK"), GetMsgText("BOOKMARK_REMINDER"), GetMsgText("DISMISS"));	
	}
	
	function onConfirmAddBookmark(param)
	{
		var lvAddBookmark = false;
		var lvBookmark = null;
	
		if (!isAndroid && !isIOS)
		{
			lvAddBookmark = (param == 1);
			lvBookmark = BookmarkManager.GetPageBookmark(onConfirmAddBookmarkIndex);
			
			if (GetObjectAsArray(lvBookmark.car).length > 1)
			{
				lvAddBookmark = false;
				
				NativeAlert("", "DISABLED adding bookmark with multiple doors/cars", "");
			}
		}	
		else if (param > 0)
		{
			lvBookmark = BookmarkManager.GetPageBookmark(onConfirmAddBookmarkIndex).Clone();		
			var lvBookmarkCar = GetObjectAsArray(lvBookmark.car);
			
			if (lvBookmarkCar.length == 1)
			{
				lvAddBookmark = param == 1;
			}
			else if (param != 3)
			{
				lvBookmark.car = lvBookmark.car[param-1];
				lvBookmark.door = lvBookmark.door[param-1];
				
				//hot fix
				
				lvBookmark.type = [lvBookmark.type[param-1]];
				
				lvAddBookmark = BookmarkManager.CanAddBookmark(lvBookmark);
				
				if (!lvAddBookmark)
				{
					NativeAlert(GetMsgText("BOOKMARK"), BookmarkManager.GetErrorMsg(), GetMsgText("DISMISS"));
				}
			}
		}
			
		if (lvAddBookmark)
		{
			BookmarkManager.AddBookmark(lvBookmark);

			NativeAlert(GetMsgText("BOOKMARK"), GetMsgText("BOOKMARK_ADDED"), GetMsgText("DISMISS"));
		}
		
		lvBookmark = null;
	}
	
function CreateHelpBar()
{
	var _TRANSLATION =
	{
		HELP: ["說明", "Help"]//,
//		HELP_CONTENT: ["乘列車到達" + GetTranslation(STATION) + "站後，請從建議位置落車，以方便轉車", "Arriving at " + GetTranslation(STATION) + " Station, please use suggested position to alight for convenient interchange"]
	};
	
	var lvString = "<div id=\"help\" data-role=\"collapsible\" data-mini=\"true\"><h3>" + _TRANSLATION.HELP[LANG] + "</h3><span id=\"helpContent\"></span></div>";
	
	_TRANSLATION = null;
	
	$("#main").prepend(lvString);
	lvString = null;
	
	SetUpHelpBar($('#help'));
	
/*	$('#help').collapsible(
	{
		collapsedIcon: "info",
		expandedIcon: "info",
		collapsed: (Load("ExpandHelpBar") != "T"),
		expand: function(event, ui)
		{
			Save("ExpandHelpBar", "T");
		},
		collapse: function(event, ui)
		{
			Save("ExpandHelpBar", "F");
		}
	});
	
	$('#help').find('div.ui-collapsible-content').addClass('ui-mini');*/
	
	SetHelpBarContentDefault();
}

function SetHelpBarContent(string)
{
	$('#helpContent').html(string);
}

function SetHelpBarContentDefault()
{
	var _TRANSLATION = ["請選擇或輸入落車站", "Please select or input alighting station"];
	
	SetHelpBarContent(_TRANSLATION[LANG]);
}

function OnTabsActivate(event, ui)
{
//	$(ui.newTab).find("a").addClass("ui-btn-active");
//	$(ui.oldTab).find("a").removeClass("ui-btn-active");
		
	Save("tabIndex", $(this).tabs('option','active'));
	
	var _TRANSLATION;
	
	var lvTabValue = $(ui.newTab).find("a").attr("href").slice(1);
	
	if (lvTabValue == "exitInfo")
	{
		 _TRANSLATION = ["查看地點以找出合適出口", "View places to identify your exit"];
		
//		SetHelpBarContent(_TRANSLATION[LANG]);
	}
	else
	{
		var lvStation = GetTranslation($('#station').val());
		var lvLine = GetCoreText(lvTabValue);
		
		 _TRANSLATION = ["<ul style=\"padding-left:10px;margin-top:0;margin-bottom:0\"><li>乘<b>" + lvLine + "</b>列車前往<b>" + lvStation + "</b>站前，預先在建議落車位置 (卡-門)上車。到達<b>" + lvStation + "</b>站後，即可從該位置落車，更快到達出口。</li><li>有關落車位置問題，請參閱<b>常見問題</b>。</li><li>可選擇「出口字母」及「常用圖案」以新增落車位置到首頁的<b>常用</b>名單。</li><li>可選擇「<b>出口資訊</b>」協助找出合適出口。</li></ul>"
		 , "<ul style=\"padding-left:10px;margin-top:0;margin-bottom:0\"><li>Before heading to <b>" + lvStation + " </b>Station by <b>" + lvLine + "</b>, board the train at the suggested alighting position (car-door). Arriving at <b>" + lvStation + "</b> Station, alight at the position to reach the exit faster.</li><li>For questions about alighting position, please refer to <b>FAQ</b>.</li><li>Press 'Exit Alphabet' and '<b>Bookmark</b>' button to bookmark alighting position to the home page.</li><li>Press '<b>Exit Info</b>' to help identifying your exit.</li></ul>"];
		
//		SetHelpBarContent(_TRANSLATION[LANG]);
	}
	
	lvTabValue = null;
	_TRANSLATION.length = 0;
}

function Init_Tab_SearchMode()
{
	if (current_search_mode == "")
	{
		current_search_mode = 0;
	}
	else
	{
		current_search_mode = parseInt(current_search_mode);
		
		if (isNaN(current_search_mode) || (current_search_mode != 0 && current_search_mode != 1))
		{
			current_search_mode = 0;
		}
	}
	
	$('#inputMethodTabs').tabs("option", "active", current_search_mode).on("tabsactivate", On_TabsActivate_SearchMode_Tab);
}

function On_TabsActivate_SearchMode_Tab(event, ui)
{
	if (current_search_mode == 1)
	{
		current_line = "";

		Init_LineSelectMenu();
		Update_StationSelectMenu();
		Set_StationInfo("");
	}

	current_search_mode = $(this).tabs('option','active');

	Save_PageData();
}

function Load_PageSavedData()
{
//	current_info_tab_index = Load("current_info_tab_index");
	current_line = Load("current_line");
	current_search_mode = Load("current_search_mode");
	current_station = Load("current_station");
}

function Save_PageData()
{
//	Save("current_info_tab_index", current_info_tab_index);
	Save("current_line", current_line);
	Save("current_search_mode", current_search_mode);
	Save("current_station", current_station);
}

function Init_LineSelectMenu()
{
	var lvSelectMenu = $('#line');
	
	var lvString = "<option value=\"N\">" + GetTranslation("SELECT_LINE") + "</option>";
	
	$.each(PRE_DEFINED.LINES, function(key, data)
	{
		lvString += "<option value=\"" + key + "\">" + GetCoreText(key) +"</option>";
	});
	
	lvSelectMenu.html(lvString);

	$('option', lvSelectMenu).prop('selected', false).filter('[value="' + current_line + '"]').prop('selected', true);

	lvSelectMenu.selectmenu("refresh");

	Set_LineSelectMenu_Border();

	lvSelectMenu = null;
	lvString = null;
}

/*function Init_StationSelectMenu()
{
//	$('#inputMethodTabs').tabs("option", "active", current_search_mode).on("tabsactivate", On_TabsActivate_SearchMode_Tab);
}*/
/*
function Set_LineSelectMenu(value)
{
	var lvSelectMenu = $('#line');
	
	$('option', lvSelectMenu).prop('selected', false).filter('[value="' + value + '"]').prop('selected', true);
	
	lvSelectMenu.selectmenu("refresh");
	
	lvSelectMenu = null;
}
*/

function Update_StationSelectMenu()
{
	var lvSelectMenu = $('#station');
	
	var lvString = "";
	
	var lvLineArray = PRE_DEFINED.LINES[current_line];
	
	if (lvLineArray != null)
	{
		for (var i=0; i<lvLineArray.length; i++)
		{
			lvString += "<option value=\"" + lvLineArray[i] + "\">" + GetTranslation(lvLineArray[i]) +"</option>";
		}
	}

	lvSelectMenu.html(lvString).selectmenu("refresh");
	
	lvSelectMenu = null;
	lvString = null;
}

function Init_SearchMode_Default()
{
	Init_LineSelectMenu();
	
	Update_StationSelectMenu();
	
	var lvSelectMenu = $('#station');
	
	$('option[value="' + current_station + '"]', lvSelectMenu).prop('selected', true);
	
	lvSelectMenu.selectmenu("refresh");
	
	Init_LineSelectMenu_Listener();
	Init_StationSelectMenu_Listener();
	
/*	$("#line").change(function(data)
	{
		var lvLineValue = this.value;
		var lvStation = $("#station");
//			var lvString = "<option value=\"N\">" + GetTranslation("SELECT_STATION") + "</option>";

		var lvString = "";
		
		if (lvLineValue == "N" || (coreXML == null && lineObj == null))
		{
			lvStation.selectmenu("disable");
		}
		else
		{
			lvStation.selectmenu("enable");
			
			if (useNewCoreXML)
			{
				if (lineObj[lvLineValue] != null)
				{
					var lvStations = lineObj[lvLineValue].station;
					
					for (var i=0; i<lvStations.length; i++)
					{
						lvString += "<option value=\"" + lvStations[i] + "\">" + GetTranslation(lvStations[i]) + "</option>";
					}
				}
			}
			else
			{
				var tmp = coreXML.children("line").filter(function(index)
				{
					return ($(this).children("code").text() == lvLineValue);
				}
				).children("station").each(function(index)
				{
					var code = $(this).text();

					lvString += "<option value=\"" + code + "\">" + GetTranslation(code) + "</option>";
				});
			}
		}
		
		lvStation.html(lvString);
//			lvStation.selectmenu("refresh");
		$('#tabs').html("");
		lvMap.button("disable");
		lvString = "";
*/		
/*		if (isRestoring)
		{
			var lvRequestStation = GetRequestParam("station");
			
			if (lvRequestStation != "")
			{
				Save("station", lvRequestStation);
				Remove("tabIndex");
				
				$('option[value=' + lvRequestStation +']', lvStation).prop('selected', 'selected').change();

				lvRequestStation = "";
			}
			else
			{
				var lvSavedStation = Load("station");
		
				if (lvSavedStation != "")
				{
					$('option[value=' + lvSavedStation +']', lvStation).prop('selected', 'selected').change();
				}
				else
				{
					isRestoring = false;
					lvSavedStation = "";
				}
			}
		}
		else if (lvLineValue != "N")
		{
			Save("line", lvLineValue);
			Remove("station");
			BookmarkManager.ClearPageBookmark();
		}
		else
		{
			Remove("line");
			BookmarkManager.ClearPageBookmark();
		}
		
		if (!isRestoring)
		{
//				lvStation.selectmenu("refresh", true);
			lvStation.change();
			
			SetHelpBarContentDefault();
		}
		
		$("#line").selectmenu("destroy");
		$("#line").selectmenu();
		$("#line-button").addClass("border_bottom_" + lvLineValue);
		
		lvLineValue = "";
	});
*/
}

function Init_SearchMode_InputStation()
{
	var lvString = '<ul id="stationListview" data-role="listview" data-filter="true" data-filter-reveal="true" data-input="#stationFilter" data-inset="true">';

	for (var i=0; i<PRE_DEFINED.STATIONS.length; i++)
	{
		lvString += '<li><a data-station="' + PRE_DEFINED.STATIONS[i] + '"href="#">' + GetTranslation(PRE_DEFINED.STATIONS[i]) + '</a></li>';
	}

	lvString += '</ul>';

	$('#tab_input_text').append(lvString);
	$('#stationListview').listview().find('a').click(function()
	{
		$('#stationFilter').val('').change();

		Set_StationInfo($(this).attr('data-station'));

		Save_PageData();
	});

	$('#stationFilter').attr('placeholder', ((LANG == 0)? '按此輸入落車站': 'Press to input Station'));

	lvString = null;
}

function Init_LineSelectMenu_Listener()
{
	$('#line').change(function(data)
	{
		current_line = this.value;

		Set_LineSelectMenu_Border();

		Update_StationSelectMenu();

		Set_StationInfo($('#station').find('option').first().val());

		Save_PageData();
	});
}

function Init_StationSelectMenu_Listener()
{
	$("#station").change(function(data)
	{
		Set_StationInfo(this.value);

		Save_PageData();
	});
}

function Set_LineSelectMenu_Border()
{
	$('#line').closest('div.ui-select').attr('class', 'ui-select border_bottom_' + current_line);
}