var VIEW_INDEX = 4;
var VIEW_INDEX_BACK = 0;

$(document).ready(function()
{
//	$.mobile.loading('show');
	overlayShow();

	GetXML("data/mode_place", ProcessCoreXML);

	InitBackButton();

	var _TRANSLATION =
	{
		headerText: ["地點指南", "Place Planner"],
		selectText: ["請選擇地點", "Please select place"],
//		refText: ["(資料僅供參考)", "(Information is for reference only)"]
		refText: [GetCoreText("REFERENCE_ONLY"), GetCoreText("REFERENCE_ONLY")]
	};

	$.each(_TRANSLATION, function(key, data)
	{
		$("#" + key).text(data[LANG]);
	});

	CreateHelpBar();

	_TRANSLATION = null;
});

function ProcessCoreXML(data)
{
	if (data == null)
	{
		return ;
	}
	
	var lvTypes = $(data).children("modePlace").children("type");
	
	if (lvTypes.length == 0)
	{
		return ;
	}
	
//	data = $.xml2json(data);
	
//	if (data == null || data.type == null)
//	{
//		return ;
//	}
		
	var lvString = "<div data-role=\"collapsible-set\">";
	var lvLangCode = GetLangCode();
	
//	$.each(data.type, function(key, data)
	for (var m=0; m<lvTypes.length; m++)
	{
		lvString += "<div data-role=\"collapsible\" data-inset=\"false\"><h3>" + $(lvTypes[m]).children(lvLangCode).text() + "</h3>";
	
		var lvPlaces = $(lvTypes[m]).children("place");
		
		if (lvPlaces.length > 0)
		{
			lvString += "<div data-role=\"collapsible-set\">"; 
		
			for (var i=0; i<lvPlaces.length; i++)
			{
				var lvPlace = $(lvPlaces[i]);
				
				lvString += "<div data-role=\"collapsible\"><h3>" + lvPlace.children(lvLangCode).text() + "</h3><ul data-role=\"listview\">";
				
				var lvStations = lvPlace.children("station");
				
				for (var j=0; j<lvStations.length; j++)
				{
					var lvStation = $(lvStations[j]);
					
					lvString += "<li><a onclick=\"PressPlace('" + lvStation.children("line").text() + "_" + lvStation.children("label").text() + "')\">" + GetCoreText("STATION_HEADER_3", ["@station", GetTranslation(lvStation.children("label").text())]) + '</a></li><li class="mode_place_exit_img"><img class="mode_place_exit" src="img/exit.png"/> '
					
					+ GetCoreText("EXIT") + " ";
					
					var lvExits = lvStation.children("exit");
					
					for (var k=0; k<lvExits.length; k++)
					{
						if (k > 0)
						{
							lvString += " / ";
						}
						
						lvString += '<div class="newExitBox mode_place_exit_box">' + $(lvExits[k]).text() + '</div>';
					}
					
					lvString += "</li>";
					
//					if (lvStation.info != null)
//					{
						var lvInfos = lvStation.children("info");
						
						for (var k=0; k<lvInfos.length; k++)
						{
							lvString += "<li>" + $(lvInfos[k]).children(lvLangCode).text() + "</li>";
						}
//					}
				}
				
				lvString += "</ul></div>";
			}
			
			lvString += "</div>";
		}

		lvString += "</div>";
	}
	
	lvString += "</div>";
	
	$('#main').append(lvString).trigger("create");

//	$.mobile.loading('hide');
	overlayHide();

	lvString = null;
	data = null;
}

function PressPlace(label)
{
	if (label != null && label != "")
	{
		label = label.split("_");
		
		if (label.length == 2)
		{
//			Location("mode_basic.html?line=" + label[0] + "&station=" + label[1] + "&lang=" + LANG);

			if (AllowStorage())
			{
				// Copy from mode_basic.js

				Save("current_line", "");
				Save("current_search_mode", "1");
				Save("current_station", label[1]);
				GoToView(1, {fromView: VIEW_INDEX});
			}
			else
			{
				GoToView(1, {station: label[1], fromView: VIEW_INDEX});
			}
		}
	}
}

function CreateHelpBar()
{
	var _TRANSLATION =
	{
		HELP: ["說明", "Help"],
		HELP_CONTENT: ["<li>推薦前往指定地點的落車站及出口</li><li>可按下<b>落車站</b>按鈕轉到<b>落車指南</b></li>", "<li>Suggest Alighting Station and Exit for designated places</li><li>Press <b>Alighting Station</b> button to switch to <b>Alighting Planner</b>"]
	};
	
	var lvString = "<div id=\"help\" data-role=\"collapsible\" data-mini=\"true\"><h3>" + _TRANSLATION.HELP[LANG] + "</h3>" + _TRANSLATION.HELP_CONTENT[LANG] + "</div>";
	
	_TRANSLATION = null;
	
	$("#main").prepend(lvString);
	lvString = null;
	
	SetUpHelpBar($('#help'));
	
/*	$('#help').collapsible(
	{
		collapsedIcon: "info",
		expandedIcon: "info",
		collapsed: (Load("ExpandHelpBar") != "T"),
		expand: function(event, ui)
		{
			Save("ExpandHelpBar", "T");
		},
		collapse: function(event, ui)
		{
			Save("ExpandHelpBar", "F");
		}
	});
	
	$('#help').find('div.ui-collapsible-content').addClass('ui-mini');*/
}