	var admobid = {};
	var isTesting = false;

	if (/android/i.test(navigator.userAgent))
	{
		admobid = { // for Android
			banner: 'ca-app-pub-4591707104442267/2485911834', // Fastpass Android
			interstitial: 'ca-app-pub-6869992474017983/1657046752'
		};

		document.removeEventListener('deviceready', InitAdMob, false);
		document.addEventListener('deviceready', InitAdMob, false);
	}
	else if (/(ipad|iphone|ipod)/i.test(navigator.userAgent))
	{
		admobid = { // for iOS
			banner: 'ca-app-pub-4591707104442267/4198683838', // Fastpass iOS
			interstitial: 'ca-app-pub-6869992474017983/7563979554'
		};

		document.removeEventListener('deviceready', InitAdMob, false);
		document.addEventListener('deviceready', InitAdMob, false);
	}
/*	else
	{
		admobid = { // for Windows Phone
			banner: 'ca-app-pub-6869992474017983/8878394753',
			interstitial: 'ca-app-pub-6869992474017983/1355127956'
		};
	}
*/

//	if ((isAndroid || isIOS) && HaveConnection())
//	{
//		document.addEventListener('deviceready', InitAdMob, false);
//	}
	
//	document.addEventListener('deviceready', InitCordovaFunc, false);
	
	function InitAdMob()
	{
		document.removeEventListener('deviceready', InitAdMob, false);

		if (AdMob)
		{
//			AdMob.hideBanner();

			if (typeof(Storage) !== "undefined")
			{
				var key = "admobLoaded";
				
				if (sessionStorage[key] != null)
				{
					return ;
				}
				else
				{
					sessionStorage.setItem(key, "1");
				}
			}

			AdMob.createBanner(
			{
				adId : admobid.banner,
				position : AdMob.AD_POSITION.BOTTOM_CENTER,
				autoShow : true,
				isTesting: isTesting
			});
		}
	}